	TITLE Tic Tac Toe
*******************************************************
* APLET VIDE 1.0							*
* by Jean-Yves Avenard						*
* Translation by Michal De Coninck				*
* optimizing by Noda						*
* If you want to compile it do the following things:	*
* >rplcomp Aplet.s Aplet.c					*
* >sasm -B -W -a Aplet.l -o Aplet.o Aplet.c		*
* >sload -H Aplet.m						*
*******************************************************

INCLUDE =Entry39.h
INCLUDE =Common.h
INCLUDE =Command.h
ASSEMBLE

*************************************************
*		     Name of the Aplet			*
*************************************************

	Dir_Head 11,Tic Tac Toe,601
*              ^1    ^2       ^3
* ^1=Lenght of the name of the aplet.
* ^2=Name of the aplet.
* ^3=Number of the library. This is necessary even if the library is empty. 

RPL
     StndtType			( This aplet skeleton will only provide access to the "C" type of aplet )
INCLUDE =Sharedvar.h
ASSEMBLE 
	Vfield  L34,IntTable
	CON(5)	=DOHSTR
	REL(5)  endLink
	Link	_Main	
	Link	_Entry
	Link	_Exit
	Link	_Action		( Include all the variables needed by the aplet structure )
	Link	_ToonRondje
	Link	_ToonKruisje
	Link	_HP40g?
	Link	_ToonTekst
	Link	_ToonCursor
	Link	_Speler1Onderstrepen
	Link	_KijkOfSpeler1GewonnenHeeft
	Link	_AI
	Link	_Speler2Onderstrepen
	Link	_AIx
	Link	_KijkOfSpeler2GewonnenHeeft
	Link	_GelijkSpel
  

endLink
RPL
DEFINE Main		INT_00
DEFINE Entry	INT_01
DEFINE Exit		INT_02
DEFINE Action	INT_03
DEFINE ToonRondje	INT_04
DEFINE ToonKruisje	INT_05
DEFINE HP40g?	INT_06
DEFINE ToonTekst	INT_07
DEFINE ToonCursor	INT_08
DEFINE Speler1Onderstrepen	INT_09
DEFINE KijkOfSpeler1GewonnenHeeft	INT_0A
DEFINE AI	INT_0B
DEFINE Speler2Onderstrepen	INT_0C
DEFINE AIx	INT_0D
DEFINE KijkOfSpeler2GewonnenHeeft	INT_0E
DEFINE GelijkSpel	INT_0F

ASSEMBLE
	Vfield  IntTable,DirVar
RPL
ASSEMBLE
	CON(5)	=DOHSTR
	REL(5)  endCode
RPL

* The HP39/40G provides a list of 91 TopicVariables that can contain any kind of object
* Instead of using local variables as on the HP48/49, it's a good idea to use these
* variables instead. The access is really fast and easy. The contain of these variables
* will be preserved while the aplet is running. If you're exiting the view or
* switch to another aplet, the content will be deleted.
* To ease the access to your variables, use alias like:

DEFINE  YCursor! TopicVar1!
DEFINE  YCursor@ TopicVar1@
DEFINE  XCursor! TopicVar2!
DEFINE  XCursor@ TopicVar2@
DEFINE  LijstA! TopicVar3!
DEFINE  LijstA@ TopicVar3@
DEFINE  LijstAX! TopicVar4!
DEFINE  LijstAX@ TopicVar4@
DEFINE  Rond! TopicVar5!
DEFINE  Rond@ TopicVar5@
DEFINE  Gewonnen! TopicVar6!
DEFINE  Gewonnen@ TopicVar6@
DEFINE  Menu! TopicVar7!
DEFINE  Menu@ TopicVar7@
DEFINE  WillekeurigGetal! TopicVar8!
DEFINE  WillekeurigGetal@ TopicVar8@
DEFINE  Spelers! TopicVar9!
DEFINE  Spelers@ TopicVar9@

ASSEMBLE
=DISPXYmini	EQU	#3F8A0					( unsupported entry to use the miniFONT )
=TOD	EQU	#3F755 						( unsupported entry for getting the exact time on the calc )
=USEROB         EQU     #80711				( needed for the code from Jordi Hidalgo )
=TRAVERSE+      EQU     #08D0F				( to check if the calc is a HP-40g or not )
=GPPushT/FLp    EQU     #0DD87
RPL 

DEFINE	Save@	LastBut3
DEFINE	Save!	LastBut3 REPLACE DROP

*************************************************
*	         Self-made variables			*
*************************************************
* ici

NAMELESS _Main
  ::
     StndCheck
     ' Entry
     ' Exit
     '
	::
	EnsureMenuOff
	;
     '
	::
	  {
	   { kcSymbView :: TakeOver Action ;	( Enter or Symb to continue the program )
	     kcEnter :: TakeOver Action ;
	   }
	   NULL{}
	   NULL{}
	   NULL{}
	   NULL{}
	   NULL{}
          }
          ONE KeyFace
       ;
    TRUE
   {
   {
	::
	;
    }
    }
    ONE
    '
    ::	TURNMENUON RECLAIMDISP
	ERRJMP
    ;
  ;
NAMELESS _Entry
::
*************************************************
*		Begin of the presentation		*
*************************************************

TURNMENUOFF
HARDBUFF ZEROZERO BINT_131d SIXTYFOUR GROB!ZERODRP

$ "    ~Tic Tac Toe~"
DISPROW1
$ "  Michal De Coninck"
DISPROW3
$ "ndco232@tiscalinet.be"
DISPROW5
$ " Press Enter to start"
DISPROW8

**************************************************
*		  End of the presentation		 *
**************************************************
;

NAMELESS _Action
::
*************************************************
*		      Begin of the program		*
*************************************************

GARBAGE								( defragmentation of the RAM )
TOD %RANDOMIZE							( take the current time as seed )

"Tic Tac Toe"							( title from menu )
{ 
{ "1 Player" ONE }						( first option 1 player )
{ "2 Players" TWO }						( second option 2 players )
}
ChooseSimple NOTcase Entry					( make the menu and if cncl is pressed than goto Entry )

Spelers!								( put the menu choice in Spelers )

Spelers@ ONE EQITE						( only one player? )
::									( then... )
$ "Who starts?"							( title )
{ { "Player 1" ONE } }						( player 1 option )
HP40g?								( is the calc a HP40g? )
ITE										
:: { { "HP-40g" TWO } } &COMP ;				( if yes, then add HP-40g as second option ) 
:: { { "HP-39g" TWO } } &COMP ;				( if no, then add HP-39g as second option )
{ { "Random" THREE } } &COMP					( third option is Random )
ChooseSimple NOTcase Action					( make the menu and if cncl is pressed than goto Action )
Menu!									( store ONE TWO or THREE in var Menu )
;									( end of ITE*1* )
::									( else... )
$ "Who starts?"							( title )
{ 
{ "Player 1" ONE } 						( first option player 1 starts )
{ "Player 2" TWO }						( second option Player 2 starts )
{ "Random" THREE }						( third option player 3 starts )
}
ChooseSimple NOTcase Action					( make the menu and if cncl is pressed than goto Action )
Menu!
;									( end of ITE*2* )

Menu@ THREE EQIT							( if third option is chosen )
::
%RAN %2 %* COERCE #1+ Menu!					( then make a random integer number between 1 and 2 ) 
;

*************************************************
*		Setting up the screen			*
*************************************************

TURNMENUOFF								( turns the menu off )
HARDBUFF ZEROZERO BINT_131d SIXTYFOUR GROB!ZERODRP	( clearscreen )

BINT85 ZERO BINT85 BINT64 LINEON				( make some lines on the screen )
BINT87 ZERO BINT87 BINT64 LINEON

BINT87 BINT31 BINT131 BINT31 LINEON
BINT87 BINT49 BINT131 BINT49 LINEON

BINT89 BINT17 					
ToonRondje								( Dutch for ShowRound )

BINT90 BINT36  
ToonKruisje								( Dutch for ShowCross )

BINT90 BINT3 BINT128 BINT3 LINEON
BINT89 BINT4 BINT89 BINT10 LINEON
BINT129 BINT4 BINT129 BINT10 LINEON
BINT90 BINT11 BINT128 BINT11 LINEON

**************************************************
*				Board		       	 *
**************************************************

BINT13 BINT2 BINT13 BINT60 LINEON
BINT71 BINT2 BINT71 BINT60 LINEON
BINT13 BINT2 BINT71 BINT2 LINEON
BINT13 BINT60 BINT71 BINT60 LINEON

BINT15 BINT4 BINT69 BINT4 LINEON
BINT15 BINT4 BINT15 BINT58 LINEON
BINT15 BINT58 BINT69 BINT58 LINEON
BINT69 BINT4 BINT69 BINT58 LINEON 

BINT33 BINT5 BINT33 BINT58 LINEON
BINT51 BINT5 BINT51 BINT58 LINEON

BINT15 BINT22 BINT69 BINT22 LINEON
BINT15 BINT40 BINT69 BINT40 LINEON

BINT14 BINT3 PIXON						( make some pixels )
BINT70 BINT3 PIXON
BINT14 BINT59 PIXON
BINT70 BINT59 PIXON

*************************************************
*		Text next to board			*
*************************************************

BINT100 BINT20							( X and Y coordinate )
$ "Player 1"							( string )
ToonTekst								( Dutch for Show Text )

BINT100 BINT38
Spelers@ ONE EQITE						( one player? )
::									( if yes then )
HP40g?								( check if the calc is a HP-40g )
ITE									( if then else structure )
$ "HP-40g"								( yes, then the string is HP-40g )
$ "HP-39g"								( no, then the string is HP-39g )
ToonTekst										
;									( end of ITE*1* )
::
$ "Player 2"							( string player 2 )
ToonTekst								( show on screen )
;									( end of ITE*2* )	

BINT89 BINT56
$ "(c) MiDeCo"
ToonTekst

BINT92 BINT5
$ "TicTacToe"
ToonTekst

*************************************************
*			Preparations 			*
*************************************************

{ ZERO ZERO ZERO ZERO ZERO ZERO ZERO ZERO ZERO } LijstA! 	( listA that represents the board ) 
* ONE= player1, TWO= player2, ZERO= empty spot
ONE LijstAX!							( we start on the first element from listA )
ZERO Gewonnen!							( you have not won yet :)
Speler1Onderstrepen						( underline player 1 because it's his turn )
Menu@ TWO EQIT							( must the computer start or player 2? )
::
Spelers@ ONE EQITE 
:: AI Speler1Onderstrepen ;					( then run AI and after that underline player 1 )
Speler2Onderstrepen						( underline player 2 because it's his turn )
;

*************************************************
*			Show Cursor 			*
*************************************************

SIXTEEN XCursor!
FIVE YCursor!

ToonCursor 								( Dutch for ShowCursor )

*************************************************
*			Getkey				*
*************************************************

BEGIN									( begin of our loop )

WaitForKey DROP DUPDUP DUPDUP DUPDUP			( waits for a key and put his code on the stack )

kcRightArrow EQ XCursor@ BINT52 EQUALNOT AND		( is the right arrow pressed and Cursor is not at the end? )
IT									( yes? then ) 
::
ToonCursor								( let's dissapear the cursor )
XCursor@ BINT18 #+ XCursor!					( update coordinates from cursor )
ToonCursor								( appearance of the cursor again )
LijstAX@ #1+ LijstAX!						( update position on the board )
;									( end of Right Arrow key )

kcLeftArrow EQ XCursor@ BINT16 EQUALNOT AND		( is the left arrow pressed and Cursor is not at the end? )
IT
::
ToonCursor
XCursor@ BINT18 #- XCursor!
ToonCursor
LijstAX@ #1- LijstAX!
;									( end of Left Arrow key )

kcDownArrow EQ YCursor@ BINT41 EQUALNOT AND		( is the Down arrow pressed and the cursor is not at the end? )
IT
::
ToonCursor
YCursor@ BINT18 #+ YCursor!
ToonCursor
LijstAX@ THREE #+ LijstAX!
;									( end of Down Arrow key ) 

kcUpArrow EQ YCursor@ FIVE EQUALNOT AND			( is the Up arrow pressed and the cursor is not at the end? )
IT
::
ToonCursor
YCursor@ BINT18 #- YCursor!
ToonCursor
LijstAX@ THREE #- LijstAX!
;									( end of Up Arrow key ) 

kcEnter EQ LijstA@ LijstAX@ NTHCOMPDROP ZERO EQ AND	( enter is pressed and current place is empty? )
IT
::
ToonCursor								( hide cursor )
Spelers@ ONE EQITE						( if there is only one player )
::
XCursor@ THREE #+ YCursor@ THREE #+				( Show Round on coordinates xcurs+3 and ycurs+3 )
ToonRondje								( Show Round )
ONE LijstAX@ LijstA@ PUTLIST LijstA!			( now the place is occupied )
KijkOfSpeler1GewonnenHeeft					( look if player 1 has won )
Gewonnen@ ONE EQUALNOT 						( if the player has not won )
IT									( then )
::
AI									( run Artificial Intelligence )
;									( end of IT )

Gewonnen@ ONE EQUALNOT 						( if the player has not won )
IT	
::									( then check for a draw )
ZERO 
TEN ONE								( quickly calculate the sum of all elements )
DO
LijstA@ INDEX@ NTHCOMPDROP #+
LOOP
BINT14 EQUAL Menu@ TWO EQ AND					( if it equals to 14 and computer has started the game then )
IT :: GelijkSpel ;						( it's a draw )
;									( end of IT )

Gewonnen@ ONE EQUALNOT						( if the player hasn't won )
IT
::
Speler1Onderstrepen						( underline player 1 again )
;									( end of IT )
;									( end of ITE*1* one player )
::

Rond@ ONE EQITE							( is it players 1 one turn? )
::
XCursor@ THREE #+ YCursor@ THREE #+				( Show Round on coordinates xcurs+3 and ycurs+3 )
ToonRondje								( Show Round )
ONE LijstAX@ LijstA@ PUTLIST LijstA!			( now the place is occupied )
KijkOfSpeler1GewonnenHeeft					( look if player 1 has won )
Speler2Onderstrepen						( underline player 2 )
;									( end of ITE*1* )
::
XCursor@ FOUR #+ YCursor@ FOUR #+				( Show Round on coordinates xcurs+3 and ycurs+3 )
ToonKruisje								( Show Round )
TWO LijstAX@ LijstA@ PUTLIST LijstA!			( now the place is occupied )
KijkOfSpeler2GewonnenHeeft					( look if player 2 has won )
Speler1Onderstrepen						( underline player 1 )
;									( end of ITE*2* player 2's turn )

ZERO 
TEN ONE								( quickly calculate the sum of all elements )
DO
LijstA@ INDEX@ NTHCOMPDROP #+
LOOP
DUP									( duplicate number )
BINT14 EQUAL Menu@ TWO EQ AND					( if it equals to 14 and computer has started the game then )
IT :: GelijkSpel ;						( it's a draw )
BINT13 EQUAL							( if it equals to 13 and you have started the game then )
IT :: GelijkSpel ;						( it's a draw )
;									( end of ITE*2* two players )
ToonCursor								( show cursor )
;									( end of Enter key )

kcDel EQ Gewonnen@ ONE EQOR					( is del pressed or have you won? )
UNTIL									( end from our loop )
DropJunk								( drop everything what isn't needed anymore  )
Entry									( then goto label Entry )

**************************************************
*		       End of the program	       *
**************************************************
;

NAMELESS _ToonRondje
::
GROB 36 B0000A00000300CC002010201010201020102020102010CC000300 	( grob "Round" )
XYGROBDISP										( show the grob )
;											( end of ToonRondje )

NAMELESS _ToonKruisje
::
GROB 2E 9000090000101028004400820001008200440028001010 		( grob "Cross" )
XYGROBDISP										( show the grob )
;											( end of ToonKruisje )

NAMELESS _HP40g?									( code from Jordi to see if the calc is a HP-40g )	
CODE
        GOSBVL  =SAVPTR
        D0=(5)  =USEROB
        A=DAT0  5
        D0=A
        D0=D0+  5
        C=DAT0  X
-       D0=D0+  13
        C=C-1   X
        GONC    -
        GOSBVL  =TRAVERSE+
        GOSBVL  =SKIPOB
        D0=D0+  7
        A=DAT0  12
        LCHEX   524944534143
        P=      11
        ?C=A    WP
        GOYES   +
+       GOVLNG  =GPPushT/FLp
ENDCODE										( end of HP40g? )

NAMELESS _ToonTekst
::
HARDBUFF										( show the text on hardbuff ) 
FOUR ROLL FOUR ROLL								( take X and Y coordinate )
FOUR ROLL DUPLEN$ 								( take the string, duplicate and give length )
FOUR #* 										( length * 4 )
DISPXYmini										( Display it in miniFont *unsupported entry* )
DROP											( drop ) 
;											( end of ToonTekst )	

NAMELESS _ToonCursor
::
XCursor@ YCursor@ 								( coordinates where the inverted grob have to be )
HARDBUFF										( on hardbuff of course )
XCursor@ YCursor@ XCursor@ BINT17 #+ YCursor@ BINT17 #+ 		( coordinates for subgrob )
SUBGROB 										( take a part of the grob )
INVGROB 										( invert above grob )		
XYGROBDISP										( now show that grob )
;											( end of ToonCursor )

NAMELESS _Speler1Onderstrepen
::
BINT100 BINT45 BINT131 BINT45 LINEOFF					( clear lines under player 2 )
BINT100 BINT46 BINT131 BINT46 LINEOFF 
BINT100 BINT27 BINT131 BINT27 LINEON 					( underline player 1 )
BINT100 BINT28 BINT131 BINT28 LINEON 
ONE Rond!										( say it's playersone turn )
;											( end of Speler1Onderstrepen )

NAMELESS _KijkOfSpeler1GewonnenHeeft
::
LijstA@ ONE NTHCOMPDROP ONE EQ						( check for all possible combinations )
LijstA@ TWO NTHCOMPDROP ONE EQ AND
LijstA@ THREE NTHCOMPDROP ONE EQ AND OR

LijstA@ FOUR NTHCOMPDROP ONE EQ
LijstA@ FIVE NTHCOMPDROP ONE EQ AND 
LijstA@ SIX NTHCOMPDROP ONE EQ AND OR

LijstA@ SEVEN NTHCOMPDROP ONE EQ
LijstA@ EIGHT NTHCOMPDROP ONE EQ AND
LijstA@ NINE NTHCOMPDROP ONE EQ AND OR

LijstA@ ONE NTHCOMPDROP ONE EQ
LijstA@ FIVE NTHCOMPDROP ONE EQ AND
LijstA@ NINE NTHCOMPDROP ONE EQ AND OR

LijstA@ THREE NTHCOMPDROP ONE EQ 
LijstA@ FIVE NTHCOMPDROP ONE EQ AND 
LijstA@ SEVEN NTHCOMPDROP ONE EQ AND OR

LijstA@ ONE NTHCOMPDROP ONE EQ
LijstA@ FOUR NTHCOMPDROP ONE EQ AND 
LijstA@ SEVEN NTHCOMPDROP ONE EQ AND OR

LijstA@ TWO NTHCOMPDROP ONE EQ
LijstA@ FIVE NTHCOMPDROP ONE EQ AND
LijstA@ EIGHT NTHCOMPDROP ONE EQ AND OR

LijstA@ THREE NTHCOMPDROP ONE EQ
LijstA@ SIX NTHCOMPDROP ONE EQ AND
LijstA@ NINE NTHCOMPDROP ONE EQ AND OR

IT										( one of them is true? )
::										( then )
BINT17 BINT29 
$ "Player 1 has won!"
ToonTekst
WaitForKey									( wait till a key is pressed )
ONE Gewonnen!								( you have won!!! Congrats )
;										( end of IT )

;										( end of KijkOfSpeler1GewonnenHeeft )

NAMELESS _AI			
::
Speler2Onderstrepen							( underline player 2 )

LijstA@ TWO NTHCOMPDROP TWO EQ					( winning is more important than blocking :)
LijstA@ THREE NTHCOMPDROP TWO EQ AND

LijstA@ FIVE NTHCOMPDROP TWO EQ
LijstA@ NINE NTHCOMPDROP TWO EQ AND OR

LijstA@ FOUR NTHCOMPDROP TWO EQ
LijstA@ SEVEN NTHCOMPDROP TWO EQ AND OR 
LijstA@ ONE NTHCOMPDROP ZERO EQ ANDcase				( if that is the case )
:: DROP TWENTY NINE ONE AIx ;						( 20=x 9=y put one on the stack, run AIx and quite AI )

LijstA@ ONE NTHCOMPDROP TWO EQ
LijstA@ THREE NTHCOMPDROP TWO EQ AND

LijstA@ FIVE NTHCOMPDROP TWO EQ
LijstA@ EIGHT NTHCOMPDROP TWO EQ AND OR
LijstA@ TWO NTHCOMPDROP ZERO EQUAL ANDcase
:: DROP THIRTYEIGHT NINE TWO AIx ;

LijstA@ ONE NTHCOMPDROP TWO EQ
LijstA@ TWO NTHCOMPDROP TWO EQ AND

LijstA@ FIVE NTHCOMPDROP TWO EQ
LijstA@ SEVEN NTHCOMPDROP TWO EQ AND OR

LijstA@ SIX NTHCOMPDROP TWO EQ
LijstA@ NINE NTHCOMPDROP TWO EQ AND OR
LijstA@ THREE NTHCOMPDROP ZERO EQ ANDcase
:: DROP FIFTYSIX NINE THREE AIx ;

LijstA@ FIVE NTHCOMPDROP TWO EQ
LijstA@ SIX NTHCOMPDROP TWO EQ AND

LijstA@ ONE NTHCOMPDROP TWO EQ
LijstA@ SEVEN NTHCOMPDROP TWO EQ AND OR
LijstA@ FOUR NTHCOMPDROP ZERO EQ ANDcase
:: DROP TWENTY TWENTYSEVEN FOUR AIx ;

LijstA@ ONE NTHCOMPDROP TWO EQ
LijstA@ NINE NTHCOMPDROP TWO EQ AND

LijstA@ TWO NTHCOMPDROP TWO EQ
LijstA@ EIGHT NTHCOMPDROP TWO EQ AND OR

LijstA@ THREE NTHCOMPDROP TWO EQ
LijstA@ SEVEN NTHCOMPDROP TWO EQ AND OR

LijstA@ FOUR NTHCOMPDROP TWO EQ
LijstA@ SIX NTHCOMPDROP TWO EQ AND OR
LijstA@ FIVE NTHCOMPDROP ZERO EQ ANDcase
:: DROP THIRTYEIGHT TWENTYSEVEN FIVE AIx ;

LijstA@ FIVE NTHCOMPDROP TWO EQ
LijstA@ FOUR NTHCOMPDROP TWO EQ AND

LijstA@ THREE NTHCOMPDROP TWO EQ
LijstA@ NINE NTHCOMPDROP TWO EQ AND OR
LijstA@ SIX NTHCOMPDROP ZERO EQ ANDcase
:: DROP FIFTYSIX TWENTYSEVEN SIX AIx ;

LijstA@ ONE NTHCOMPDROP TWO EQ
LijstA@ FOUR NTHCOMPDROP TWO EQ AND

LijstA@ FIVE NTHCOMPDROP TWO EQ
LijstA@ THREE NTHCOMPDROP TWO EQ AND OR

LijstA@ EIGHT NTHCOMPDROP TWO EQ
LijstA@ NINE NTHCOMPDROP TWO EQ AND OR 
LijstA@ SEVEN NTHCOMPDROP ZERO EQ ANDcase
:: DROP TWENTY BINT45 SEVEN AIx ;

LijstA@ TWO NTHCOMPDROP TWO EQ
LijstA@ FIVE NTHCOMPDROP TWO EQ AND

LijstA@ SEVEN NTHCOMPDROP TWO EQ
LijstA@ NINE NTHCOMPDROP TWO EQ AND OR
LijstA@ EIGHT NTHCOMPDROP ZERO EQ ANDcase
:: DROP THIRTYEIGHT BINT45 EIGHT AIx ;

LijstA@ SIX NTHCOMPDROP TWO EQ
LijstA@ THREE NTHCOMPDROP TWO EQ AND

LijstA@ EIGHT NTHCOMPDROP TWO EQ
LijstA@ SEVEN NTHCOMPDROP TWO EQ AND OR

LijstA@ ONE NTHCOMPDROP TWO EQ
LijstA@ FIVE NTHCOMPDROP TWO EQ AND OR 
LijstA@ NINE NTHCOMPDROP ZERO EQ ANDcase
:: DROP FIFTYSIX BINT45 NINE AIx ;


LijstA@ TWO NTHCOMPDROP ONE EQ					( from here starts the blocking )
LijstA@ THREE NTHCOMPDROP ONE EQ AND

LijstA@ FIVE NTHCOMPDROP ONE EQ
LijstA@ NINE NTHCOMPDROP ONE EQ AND OR

LijstA@ FOUR NTHCOMPDROP ONE EQ
LijstA@ SEVEN NTHCOMPDROP ONE EQ AND OR 
LijstA@ ONE NTHCOMPDROP ZERO EQ ANDcase				( if that is the case )
:: DROP TWENTY NINE ONE AIx ;		

LijstA@ ONE NTHCOMPDROP ONE EQ
LijstA@ THREE NTHCOMPDROP TWO EQ AND

LijstA@ FIVE NTHCOMPDROP ONE EQ
LijstA@ EIGHT NTHCOMPDROP ONE EQ AND OR
LijstA@ TWO NTHCOMPDROP ZERO EQUAL ANDcase
:: DROP THIRTYEIGHT NINE TWO AIx ;

LijstA@ ONE NTHCOMPDROP ONE EQ
LijstA@ TWO NTHCOMPDROP ONE EQ AND

LijstA@ FIVE NTHCOMPDROP ONE EQ
LijstA@ SEVEN NTHCOMPDROP ONE EQ AND OR

LijstA@ SIX NTHCOMPDROP ONE EQ
LijstA@ NINE NTHCOMPDROP ONE EQ AND OR
LijstA@ THREE NTHCOMPDROP ZERO EQ ANDcase
:: DROP FIFTYSIX NINE THREE AIx ;

LijstA@ FIVE NTHCOMPDROP ONE EQ
LijstA@ SIX NTHCOMPDROP ONE EQ AND

LijstA@ ONE NTHCOMPDROP ONE EQ
LijstA@ SEVEN NTHCOMPDROP ONE EQ AND OR
LijstA@ FOUR NTHCOMPDROP ZERO EQ ANDcase
:: DROP TWENTY TWENTYSEVEN FOUR AIx ;

LijstA@ ONE NTHCOMPDROP ONE EQ
LijstA@ NINE NTHCOMPDROP ONE EQ AND

LijstA@ TWO NTHCOMPDROP ONE EQ
LijstA@ EIGHT NTHCOMPDROP ONE EQ AND OR

LijstA@ THREE NTHCOMPDROP ONE EQ
LijstA@ SEVEN NTHCOMPDROP ONE EQ AND OR

LijstA@ FOUR NTHCOMPDROP ONE EQ
LijstA@ SIX NTHCOMPDROP ONE EQ AND OR
LijstA@ FIVE NTHCOMPDROP ZERO EQ ANDcase
:: DROP THIRTYEIGHT TWENTYSEVEN FIVE AIx ;

LijstA@ FIVE NTHCOMPDROP ONE EQ
LijstA@ FOUR NTHCOMPDROP ONE EQ AND

LijstA@ THREE NTHCOMPDROP ONE EQ
LijstA@ NINE NTHCOMPDROP ONE EQ AND OR
LijstA@ SIX NTHCOMPDROP ZERO EQ ANDcase
:: DROP FIFTYSIX TWENTYSEVEN SIX AIx ;

LijstA@ ONE NTHCOMPDROP ONE EQ
LijstA@ FOUR NTHCOMPDROP ONE EQ AND

LijstA@ FIVE NTHCOMPDROP ONE EQ
LijstA@ THREE NTHCOMPDROP ONE EQ AND OR

LijstA@ EIGHT NTHCOMPDROP ONE EQ
LijstA@ NINE NTHCOMPDROP ONE EQ AND OR 
LijstA@ SEVEN NTHCOMPDROP ZERO EQ ANDcase
:: DROP TWENTY BINT45 SEVEN AIx ;

LijstA@ TWO NTHCOMPDROP ONE EQ
LijstA@ FIVE NTHCOMPDROP ONE EQ AND

LijstA@ SEVEN NTHCOMPDROP ONE EQ
LijstA@ NINE NTHCOMPDROP ONE EQ AND OR
LijstA@ EIGHT NTHCOMPDROP ZERO EQ ANDcase
:: DROP THIRTYEIGHT BINT45 EIGHT AIx ;

LijstA@ SIX NTHCOMPDROP ONE EQ
LijstA@ THREE NTHCOMPDROP ONE EQ AND

LijstA@ EIGHT NTHCOMPDROP ONE EQ
LijstA@ SEVEN NTHCOMPDROP ONE EQ AND OR

LijstA@ ONE NTHCOMPDROP ONE EQ
LijstA@ FIVE NTHCOMPDROP ONE EQ AND OR 
LijstA@ NINE NTHCOMPDROP ZERO EQ ANDcase
:: DROP FIFTYSIX BINT45 NINE AIx ;

ZERO 										( check if it's a draw )
TEN ONE									( quickly calculate the sum of all elements )
DO
LijstA@ INDEX@ NTHCOMPDROP #+
LOOP
BINT13 EQUAL case GelijkSpel						( yes? then goto GelijkSpel )

BEGIN										( begin of our loop )
%RAN %9 %* COERCE #1+ WillekeurigGetal!				( randomly place a cross on the board )	
LijstA@ WillekeurigGetal@ NTHCOMPDROP ZERO EQUAL		( check if the place is empty or )
UNTIL										( if so quite the loop )

WillekeurigGetal@								( if random number is one )
ONE EQcase
:: DROP TWENTY NINE ONE AIx ;						( you know the drill by now :)

WillekeurigGetal@
TWO EQcase
:: DROP THIRTYEIGHT NINE TWO AIx ;

WillekeurigGetal@
THREE EQcase
:: DROP FIFTYSIX NINE THREE AIx ;

WillekeurigGetal@
FOUR EQcase
:: DROP TWENTY TWENTYSEVEN FOUR AIx ;

WillekeurigGetal@
FIVE EQcase
:: DROP THIRTYEIGHT TWENTYSEVEN FIVE AIx ;

WillekeurigGetal@
SIX EQcase
:: DROP FIFTYSIX TWENTYSEVEN SIX AIx ;

WillekeurigGetal@
SEVEN EQcase
:: DROP TWENTY BINT45 SEVEN AIx ;

WillekeurigGetal@
EIGHT EQcase
:: DROP THIRTYEIGHT BINT45 EIGHT AIx ;

WillekeurigGetal@
NINE EQcase
:: DROP FIFTYSIX BINT45 NINE AIx ;
;										( end of Artificial Intelligence )

NAMELESS _Speler2Onderstrepen
::
BINT100 BINT27 BINT131 BINT27 LINEOFF 				( clear lines under player 1 )
BINT100 BINT28 BINT131 BINT28 LINEOFF 
BINT100 BINT45 BINT131 BINT45 LINEON BINT100 			( underline player 2 )
BINT46 BINT131 BINT46 LINEON 
TWO Rond! 									( say it's players two's turn )
;										( end of Speler2Onderstrepen )

NAMELESS _AIx
::
TWO SWAP LijstA@ PUTLIST LijstA!					( update list representing the board )
ToonKruisje
KijkOfSpeler2GewonnenHeeft						( look if player 2 has won )
;										( end of Artificial intelligence x )

NAMELESS _KijkOfSpeler2GewonnenHeeft
::
LijstA@ ONE NTHCOMPDROP TWO EQ
LijstA@ TWO NTHCOMPDROP TWO EQ AND
LijstA@ THREE NTHCOMPDROP TWO EQ AND OR

LijstA@ FOUR NTHCOMPDROP TWO EQ
LijstA@ FIVE NTHCOMPDROP TWO EQ AND
LijstA@ SIX NTHCOMPDROP TWO EQ AND OR

LijstA@ SEVEN NTHCOMPDROP TWO EQ
LijstA@ EIGHT NTHCOMPDROP TWO EQ AND
LijstA@ NINE NTHCOMPDROP TWO EQ AND OR

LijstA@ ONE NTHCOMPDROP TWO EQ
LijstA@ FIVE NTHCOMPDROP TWO EQ AND
LijstA@ NINE NTHCOMPDROP TWO EQ AND OR

LijstA@ THREE NTHCOMPDROP TWO EQ 
LijstA@ FIVE NTHCOMPDROP TWO EQ AND 
LijstA@ SEVEN NTHCOMPDROP TWO EQ AND OR

LijstA@ ONE NTHCOMPDROP TWO EQ
LijstA@ FOUR NTHCOMPDROP TWO EQ AND
LijstA@ SEVEN NTHCOMPDROP TWO EQ AND OR

LijstA@ TWO NTHCOMPDROP TWO EQ
LijstA@ FIVE NTHCOMPDROP TWO EQ AND 
LijstA@ EIGHT NTHCOMPDROP TWO EQ AND OR

LijstA@ THREE NTHCOMPDROP TWO EQ
LijstA@ SIX NTHCOMPDROP TWO EQ AND
LijstA@ NINE NTHCOMPDROP TWO EQ AND OR

IT										( one of them is true? )
::										( then... )
Spelers@ ONE EQITE
::
FOUR BINT29 								( coordinates where to display the text )
HP40g? 									( is the calc a HP40g )
ITE										( if then else ) 
"The HP-40g" 								( yes, then string the HP-40g )
"The HP-39g" 								( no, then string the HP-39g )			
" has won!" &$								( concatenate the two strings )
ToonTekst									( display the text )
WaitForKey									( wait till a key is pressed )
ONE Gewonnen! 								( The HP-39/40g has won!!! loser :)
;										( end of ITE*1* one player )
::
BINT10 BINT29 								( coordinates )
$ "Player 2 has won!"							( string Player 2 has won )
ToonTekst									( display text )
WaitForKey									( wait till a key is pressed )
ONE Gewonnen! 								( you have won!!! congrats )
;										( end of ITE*2* two players )
;										( end of IT )

;										( end of KijkOfSpeler2GewonnenHeeft )

NAMELESS _GelijkSpel
::
TWENTY BINT29 								( coordinates )
$ "It's a Draw!"								( string it's a draw )
ToonTekst									( show it on the screen )
WaitForKey									( display it till a key is pressed )
ONE Gewonnen!								( it's a draw this is needed to quite the getkey loop )
;										( end of GelijkSpel )

NAMELESS _Exit
  ::
   LeaveGraphView
  ;
ASSEMBLE
endCode
RPL
ASSEMBLE
	Vfield DirVar,DirCode

* This variable will contain all the saved parameters of the aplet
* You can add your own variable in the list

RPL
  {
  ONE		( Add your default parameters here for the variable 'save' )
  }
ASSEMBLE
	Vfield DirCode,DirAlt
RPL
  { }
ASSEMBLE
	Vfield DirAlt,DirNot
RPL

**************************************************
*		     Note of the aplet			 *
**************************************************
* if you want to put text in a note do it here   *
* beneath, between the " "				 *
**************************************************

$ "    ~Tic Tac Toe~\nKeys:\n[Arrow Keys] move cursor\n[Enter] Place cursor\nNew in version 1.2:\n*Fixed wrong signs bug!\n*You can now choose if you want to start or the computer/player 2!\n*Different versions for HP-39/40g\nSend comments, bugs to ndco232@tiscalinet.be\n(c) 2003 Michal De Coninck"

ASSEMBLE
	Vfield DirNot,DirEnd
RPL
  { }
